package com.jxdinfo.hussar.core.cache;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jxdinfo.hussar.core.cache.Cache;
import com.jxdinfo.hussar.core.cache.CacheEntry;
import com.jxdinfo.hussar.core.cache.LRULinkedHashMap;
import java.util.concurrent.locks.ReentrantLock;

public class DefaultCache implements Cache {
  private LRULinkedHashMap<String, CacheEntry> e;
  
  private ReentrantLock do;
  
  public Object remove(String str) {
    this.do.lock();
    try {
      CacheEntry cacheEntry;
      if ((cacheEntry = (CacheEntry)this.e.remove(str)) != null)
        return cacheEntry.getValue(); 
      return null;
    } finally {
      this.do.unlock();
    } 
  }
  
  public Object get(String str, long l) {
    this.do.lock();
    try {
      CacheEntry cacheEntry;
      if ((cacheEntry = (CacheEntry)this.e.get(str)) != null) {
        if (cacheEntry.getExpires() > System.currentTimeMillis() && cacheEntry.getVersion() == l) {
          int i;
          cacheEntry.setHits((i = cacheEntry.getHits()) + 1);
        } 
        this.e.remove(str);
      } 
      return null;
    } finally {
      this.do.unlock();
    } 
  }
  
  public DefaultCache(int i) {
    this;
    super(i);
    ((com.jxdinfo.hussar.core.cache.DefaultCache)new LRULinkedHashMap()).e = (LRULinkedHashMap<String, CacheEntry>)this;
    this.do = new ReentrantLock(false);
  }
  
  public void put(String str, long l1, long l2, Object object) {
    this.do.lock();
    try {
      object = new CacheEntry(object);
      object.setExpires(l1 * 1000L);
      object.setVersion(l2);
      this.e.put(str, object);
      return;
    } finally {
      this.do.unlock();
    } 
  }
  
  public void put(String str, long l, Object object) {
    this.do.lock();
    try {
      object = new CacheEntry(object);
      object.setExpires(l * 1000L);
      this.e.put(str, object);
      return;
    } finally {
      this.do.unlock();
    } 
  }
  
  public Object get(String str) {
    this.do.lock();
    try {
      CacheEntry cacheEntry;
      if ((cacheEntry = (CacheEntry)this.e.get(str)) != null) {
        if (System.currentTimeMillis() < cacheEntry.getExpires()) {
          int i;
          cacheEntry.setHits((i = cacheEntry.getHits()) + 1);
          return cacheEntry.getValue();
        } 
        this.e.remove(str);
      } 
      return null;
    } finally {
      this.do.unlock();
    } 
  }
}
